

//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------

//SYSINFO
#define DATUM		"27.03.2012"
#define UHRZEIT		"12:00"
#define FUNKTION	"Minimale Konfig."
#define HARDWARE	"AVR ATMega16 Own Brew Board V2G"
#define SOFTWARE	"Grundlegende Software mit Hardware Polling"
#define AUX_TEXT	"TickCounter mit LEDLEIST an Port C"
#define AUTOR		"Christof Ermer"
#define IHAVENOBRAIN	"I have no brain."	
#define USEYOURS		"Use your own"
#define BAUDRATE	"9600,8,N,1"
/*
HYSTORY 
In Interupts...alle Vars deklarieren mit 
volatile uint32_t Tickscounter..
*/

/*
#define UART_BAUD_RATE	9600
#define F_CPU	16000000
*/

#include <ctype.h>
#include <inttypes.h>
#include <avr\io.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <avr\interrupt.h>  // obsolete #include <avr\signal.h>

#include <avr\wdt.h>
//Produziert Fehler...
#include <util\delay.h>	//_delay_loop_1 _delay_loop_2 delay_ms

#include "avr_register.h"		//with Hardware assigns
#include "main.h"		//with Hardware assigns
#include "uart.h"


int32_t Round(double fIn);

#ifdef TIMER_TICK_USED
void StartTickTimer(void);	//0.1 Seconds  interrupt
#endif


#ifdef UART_USE_ENABLED
void UART_TXRX_Check(void);
void ResetRxBuff(void);
void PrintCR(void);
void PrintStrCR(const char* pStr);
void Print_PStrCR(PGM_P pmStr);
void CheckOrder(char* pcStr);
void LongToNumStr(int32_t lVal);
void PrintLongCR(int32_t lVal);
void FloatToNumStr(double fVal);
#endif


//CONSTANT ARRAYs IN .TEXT = ROM ARREA   .DATA IST SRAM !! .BSS SRAM
//const char MCA_DELIMTERSTR[] PROGMEM = { ',',0 };

// GLOBALE VARIABLEN 
//MSG
const char MCA_DELIMITER_MSG[] PROGMEM	= ",";

#ifdef UART_USE_ENABLED 
static char* gpcRxPars;
static char gcaRxStr[RX_STRMAX + 1]; //+1 for the 0
static char gcaNumStr[NUMMAX + 1]; //+1 for the 0
static char gcaStr[STRMAX + 1]; //+1 for the 0
static COMMAND_TYPE gsCmd;
#endif

//static uint8_t gcaSegmentStr[SEGMENTSTRMAX + 1]; //+1 for the 0
static volatile  uint32_t gu32_Ticks; //  T2 timeCounter, only NN_Counter for Keypressings
#ifdef USE_ERROR_FLAG 
uint8_t gbErrorFlag;
#endif

#define PROG_Mode_BLINK_LED	0x01
uint8_t gu8ProgMode = 0;


#ifdef TIMER_TICK_USED 
// ****************************************************************
//volatile  SIGNAL(TIMER2_OVF_vect) //oder SIGNAL--INTERRUPT(SIG_OVERFLOW2) = mit SEI am Anfang
SIGNAL( TIMER2_OVF_vect ) //oder SIGNAL--INTERRUPT(SIG_OVERFLOW2) = mit SEI am Anfang
// *******************************************************************
{
sei();
//cli();/ 
gu32_Ticks++;
#ifdef UART_USE_ENABLED
UART_TXRX_Check();	//IMMER VORNAHANDEN !! IN ALLEN LOOPS DIE ZEIT BRAUCHEN
#endif
};
#endif

	

// *************************************
void StartTickTimer(void)	//0.1 Seconds  interrupt
//Normal MODE OC2 Disconnect Prescale 64
// *************************************
{
unsigned char sreg;
sreg = SREG; //loakaler Speicher
cli();
//TIMSK &=  (~(_BV(TOIE2)) & ~(_BV(OCIE2)));
TIMSK &= ~( TIMSK_TOIE2_FLAG | TIMSK_OCIE2_FLAG );
gu32_Ticks = 0;
OCR2 = 0;
TCNT2 = 0;  //Timer MAX = TOP Compare
TIFR |= TIFR_OCF2_OUTP_COMPARE_FLAG | TIFR_TOV2_TIMER_OVERFLOW_FLAG ; // zum lschen setzen!
//TIMER STARTS with Presscale Select = 64
TCCR2 = TCCR2_CLK_256;	// 0000 0100//Timer Counter CTRL -- NORMAL MODE=NO OCR2
//TCCR2 = TCCR2_CLK_0;	//
TIMSK |= TIMSK_TOIE2_FLAG; //_BV(TOIE2); // BESSER == OVERFLOW 
SREG = sreg;
sei();
};


#ifdef UART_USE_ENABLED 
// *******************************************************************
void UART_TXRX_Check(void)
/*	
* Get received character from ringbuffer
* uart_getc() returns in the lower byte the received character and
* in the higher byte (bitmask) the last receive error
* UART_NO_DATA is returned when no data is available.
*/
// *******************************************************************
{
uint16_t uiRxUart;
uiRxUart = uart_getc();//!FETCH ALLWAYS BYTE FROM RX RINGBUFF INTERRUPT!
if ( !(uiRxUart & UART_NO_DATA) )  //0x0100
	{
//   * new data available from UART
//  * check for Frame or Overrun error
#ifdef UART_ERRORMSG 
	if ( uiRxUart & (UART_FRAME_ERROR | UART_OVERRUN_ERROR | UART_BUFFER_OVERFLOW) )
		{
		ResetRxBuff();
		uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );// !! Init UART interface
// Framing Error detected, i.e no stop bit detected
		Print_PStrCR(  PSTR("UartErr") );
		};
#endif
//NOW SELCT ACTION FROM ORDER
//Check CR
	if(gpcRxPars < (gcaRxStr + RX_STRMAX))	//ENDANSCHLAG ERREICHT ?
		{
		switch( (unsigned  char)uiRxUart  )
			{
			case 13: // order!! from Terminal
				{
				CheckOrder(gcaRxStr);//gcaRxStr = accumulated str
				ResetRxBuff();
				break;
				};	           				
			default: //Accumulate
				{
      // Accumulate String only to gcaRxStr with uiAAA Parser
				*gpcRxPars++ = (unsigned  char)(uiRxUart & 0x0FF);//Append rxByte
				*gpcRxPars = 0; //ZERO carry
				};
			};//switch
		}// if (pcRxPars < (gcaRxStr + RXSTRMAX))
	else  // To much data Rx, than clear simple all
		{
	 //overflow of RX clears all
		ResetRxBuff();	// Clear Rx Parspointer in Buff an terminate RxStr with 0
		};//if(gpcRxPars < (gcaRxStr + RXSTRMAX))
// ENDE DER RX EMPFANGSAUSWERTUNG
	};
};
#endif




#ifdef UART_USE_ENABLED 
// *******************************************************************
void ResetRxBuff(void)
// *******************************************************************
{
gpcRxPars = gcaRxStr; // Set parse pointer back;
*gpcRxPars = 0;	//clear Rx
};
#endif

#ifdef UART_USE_ENABLED   //MAKLEFILE ANPASSEN

#define FLOAT_PRAEDIGITS_MAX	6 // DIgits nach //dtostrf(fVal,NUMMAX, DIGITS_MAX, gcaNumStr);
#define FLOAT_DIGITS_MAX		3 // DIgits nach //dtostrf(fVal,NUMMAX, DIGITS_MAX, gcaNumStr);
// *******************************************************************
void PrintCR(void)
// *******************************************************************
{
uart_putc( ASC_CR );
};

// *******************************************************************
void PrintStrCR(const char* pStr)
// *******************************************************************
{
uart_puts(pStr);
PrintCR();
};


// *******************************************************************
void Print_PStrCR(PGM_P pmStr)
// *******************************************************************
{
uart_puts_p(pmStr);
PrintCR();
};

// **********************************************
void FloatToNumStr(double fVal)
// *************
{
dtostrf(fVal, FLOAT_PRAEDIGITS_MAX, FLOAT_DIGITS_MAX, gcaNumStr ); //[-]d.ddd
};

// **********************************************
void LongToNumStr(int32_t lVal)
// **********************************************
{ 
ltoa(lVal, gcaNumStr, 10 );
};

// **********************************************
void ULongToNumStr(uint32_t ulVal)
// **********************************************
{ 
ultoa(ulVal, gcaNumStr, 10 );
};


// *******************************************************************
void PrintLongCR(int32_t lVal)
// *******************************************************************
{
LongToNumStr(lVal); PrintStrCR(gcaNumStr);
};

void PrintULongCR(uint32_t ulVal)
// *******************************************************************
{
ULongToNumStr(ulVal); PrintStrCR(gcaNumStr);
};

// *******************************************************************
void PrintFloatCR(double fVal)
// *******************************************************************
{
FloatToNumStr(fVal); PrintStrCR(gcaNumStr);
};
#endif



// *******************************************************************
void CheckOrder(char *pcStrOrder) //von gcaRxStr
// *******************************************************************
{ //INPUT ERWARTET INDER FOR "BEFEHL,WERT" BSP: "SFR,1000"
//uint16_t uiCnt =0;
char * pStrTok; // fr strtok_r
char * pucCh = &pcStrOrder[ strlen(pcStrOrder) ]; // Stelle POINTER auf \0 Ende  // kein unsigned char*

strcpy(gcaStr, pcStrOrder);
strcpy_P(gcaNumStr, MCA_DELIMITER_MSG); //HILFSWEISE gcaNumStr fr ","

if( (pStrTok = strtok_r( pcStrOrder, gcaNumStr  , &pucCh)) != NULL)//Trenne CMD, von ID, -"$$$1,CMD
	{	
	strcpy(gsCmd.ucaCmd, pStrTok);
	}
else
	{
	*gsCmd.ucaCmd = 0;
	};
gsCmd.ucaCmd[ COMAMNDSIZEMAX ] = 0; //Sicherheitsterminierung COMAMNDSIZEMAX=10


//strcpy(gcaStr, pcStrOrder);

gsCmd.fCmdVal_1 = gsCmd.fCmdVal_2 = 0;
if( (pStrTok = strtok_r( NULL,  gcaNumStr, &pucCh)) != NULL)
	{
	gsCmd.fCmdVal_1 = atof(pStrTok);// Und dann TO Float	
	};
	
if( (pStrTok = strtok_r( NULL,  gcaNumStr, &pucCh)) != NULL)
	{
	gsCmd.fCmdVal_2 = atof(pStrTok);// Und dann TO Float	
	};

//========================================================================================

	
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("PING") )  )    //ping
	{	
	Print_PStrCR( PSTR("PONG") );	
	return;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("TT") ) )
	{
	PrintLongCR( gu32_Ticks );
	return;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("RR") ) )
	{
	gu32_Ticks = 0; //Reset TickCounter ( nur so eine Spielerei )
	return;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("MM") ) )
	{
	PrintLongCR( gu8ProgMode ); // zeig emir an welche Status das ProgModeFlag hat
	return;
	};
	
 };


// *******************************************************************
int main(void)
// *******************************************************************
{
static uint32_t u32Now;
//static uint16_t u16Toggle;

//INITS
cli();//The global interrupt flag is maintained in the I bit of the status register (SREG).  
//Wichtige Schritte.. so bald wie mglich

//INIT HARDWARE
//USing of PORTOUTS  1=OUT, 0=IN
DDRA = PORTA_DDRX_OUTMASK;
PORTA = PORTA_PRESET_PULLMASK;
DDRB = PORTB_DDRX_OUTMASK;
PORTB = PORTB_PRESET_PULLMASK;
DDRC = PORTC_DDRX_OUTMASK;
PORTC = PORTC_PRESET_PULLMASK;

#ifndef Board_V2G_HARDWARE_POLLING
DDRD = PORTD_DDRX_OUTMASK;	
PORTD = PORTD_PRESET_PULLMASK;
#else
DDRD = PORTD_DDRX_BOARD_V2G_AUX_MSK;
PORTD = PORTD_BOARD_V2G_AUX_PULLUP_MSK;
#endif
//SFIOR = (1<<PUD); //Pullup Disable

StartTickTimer();	//8 Bit Timer 2 = MS Tick Counter
//Pointer and Strings init
wdt_enable(WDTO_2S); //Set 1.9Sec WatchDog ENABLE
wdt_reset();   //WATCHDOG!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

// Initialize UART library, pass baudrate and avr cpu clock
// with the macro UART_BAUD_SELECT()
ResetRxBuff();
uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );

Print_PStrCR( PSTR(HARDWARE) );
Print_PStrCR( PSTR(SOFTWARE) );
Print_PStrCR( PSTR(AUX_TEXT) );

Print_PStrCR( PSTR(AUTOR) );
Print_PStrCR( PSTR(FUNKTION) );
Print_PStrCR( PSTR(DATUM) );
Print_PStrCR( PSTR(IHAVENOBRAIN) );
Print_PStrCR( PSTR(USEYOURS) );
uart_puts_p( PSTR("UART-Baud="));
Print_PStrCR( PSTR(BAUDRATE) );


u32Now = 0;
gu32_Ticks = 0;
sei();
// ************ MAIN LOOP FOR EVER *********************
for (;;)  /* loop forever */ //Aber schnell > 200.000 mal/Sekunde
	{	
 	wdt_reset();	//WATCHDOG!

	if( (gu32_Ticks -u32Now)  > PULS_1000MS_Tick )
		{
		u32Now = gu32_Ticks; //Zeit merken !!
		//Hier kann was gemacht werden jede 1 Sekunde
		};
		

#ifdef Board_V2G_HARDWARE_POLLING
	if(PIND & KEY1_BIT)
		{
		if( !(gu8ProgMode & PROG_Mode_BLINK_LED) )		
			{PORTD &= ~LED1_BIT;};
		}		
	else
		{
		PORTD |= LED1_BIT;
		};
	
	if(PIND & KEY2_BIT)
		{
		if( !(gu8ProgMode & PROG_Mode_BLINK_LED) )		
			{PORTD &= ~LED2_BIT;};
		}
	else
		{
		PORTD |= LED2_BIT;
		};
		
	if(PIND & KEY3_BIT)		
		{
		gu8ProgMode &= ~PROG_Mode_BLINK_LED;
		}
	else
		{
		gu8ProgMode |= PROG_Mode_BLINK_LED;
		};
#endif

	}; //main loop Ende
};
// ******************* MAIN END ********************************************
